--  file  : speed.ex
--  author: jiri babor
--  email : jbabor@paradise.net.nz
--  date  : 98-11-03

include font.e
include get.e

constant
    s="the quick brown fox jumps over a lazy dog...",
    N=100
object junk
atom t,dt

procedure pause(atom dt)
    atom t
    t=time()+dt
    while time()<t do end while  -- waste time
end procedure

-- main ------------------------------------------------------------------------
junk=graphics_mode(18)
tick_rate(100)
pause(.5)   -- wait for stable mode

position(8,1)
text_color(BRIGHT_WHITE)
puts(1, "100 iterations - mode 18:")

set_foreground(BRIGHT_BLUE)
set_background(CLEAR)
t=time()
for i=1 to N do
    setx(0) sety(0)
    write(s)
end for
dt=time()-t
position(10,1)
text_color(9)
printf(1,"ROM font:  CLEAR background: %5.2f s", dt)

set_foreground(YELLOW)
set_background(BLACK)
t=time()
for i=1 to N do
    setx(0) sety(20)
    write(s)
end for
dt=time()-t
position(11,1)
text_color(YELLOW)
printf(1,"ROM font:  BLACK background: %5.2f s", dt)

t=time()
text_color(BRIGHT_RED)
for i=1 to N do
    position(4,1)
    puts(1,s)
end for
dt=time()-t
position(12,1)
printf(1,"Native system 8x14 rom font: %5.2f s", dt)

junk=wait_key()
junk=graphics_mode(-1)
